from netgen.csg import *
from ngsolve import *

spline = SplineCurve2d() 

H = 1 
R = 0.1 

pnts = [ (0,0), (0,R), (H/4,4*R), (H,R), (H,0) ]
segs = [ (0,1), (1,2,3), (3,4) ]

for pnt in pnts:
    spline.AddPoint(*pnt)
for seg in segs:
    spline.AddSegment(*seg)

rev = Revolution(Pnt(0,0,0), Pnt(0,1,0), spline)

geo = CSGeometry()
geo.Add(rev.col([1,0,0]))
geo.Draw()

mesh = geo.GenerateMesh(maxh=0.5, optsteps2d=3)
mesh = Mesh(mesh)	
mesh.Curve(3)	
Draw(mesh)
